# PStringList Class Reference

This is a list collection class of `PString` objects. More...

`#include <pstring.h>`

Inheritance diagram for PStringList:

List of all members.

## Operations

PINDEX | AppendString (const PString &str)
| Append a string to the list.
PINDEX | InsertString (const PString &before, const PString &str)
| Insert a string into the list.
PINDEX | GetStringsIndex (const PString &str) const
| Get the index of the string with the specified value.
PStringList & | operator+= (const PStringList &list)
| Concatenate a PString or PStringArray to the list.
PStringList & | operator+= (const PString &str)
PStringList | operator+ (const PStringList &array)
| Create a new PStringList, and add PString or PStringList to it a new PStringList.
PStringList | operator+ (const PString &str)
template<typename stlContainer>
static PStringList | container (const stlContainer &vec)
| Create a PStringArray from an STL container.

## Public Member Functions

Construction
| PStringList (PINDEX count, char const *const *strarr, PBoolean caseless=false)
| Create a PStringList from the array of C strings.
| PStringList (const PString &str)
| Create a PStringList of length one from the single string.
| PStringList (const PStringArray &array)
| Create a PStringList from the array of strings.
| PStringList (const PSortedStringList &list)
| Create a PStringList from the sorted list of strings.
Overrides from class PObject
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream.

## Detailed Description

This is a list collection class of `PString` objects.

It has all the usual functions for a collection, with the object types set to `PString` pointers.

In addition some addition functions are added that take a const `PString` reference instead of a pointer as most standard collection functions do. This is more convenient for when string expressions are used as parameters to function in the collection.

See the `PAbstractList` and `PList` classes and `PDECLARE_LIST` macro for more information.

## Constructor & Destructor Documentation

PStringList::PStringList | ( | PINDEX | count,
|  | char const *const * | strarr,
|  | PBoolean | caseless = `false` |
| ) |  |  |

Create a PStringList from the array of C strings.

Parameters:

  count | Count of strings in array
  strarr | Array of C strings
  caseless | New strings are to be PCaselessStrings

PStringList::PStringList | ( | const PString & | str | ) |

Create a PStringList of length one from the single string.

Parameters:

  str | Single string to convert to a list of one.

PStringList::PStringList | ( | const PStringArray & | array | ) |

Create a PStringList from the array of strings.

Parameters:

  array | Array of strings to convert to list

PStringList::PStringList | ( | const PSortedStringList & | list | ) |

Create a PStringList from the sorted list of strings.

Parameters:

  list | List of strings to convert to list.

## Member Function Documentation

PINDEX PStringList::AppendString | ( | const PString & | str | ) |

Append a string to the list.

Parameters:

  str | String to append.

template<typename stlContainer>

static PStringList PStringList::container | ( | const stlContainer & | vec | ) | `[inline, static]`

Create a PStringArray from an STL container.

PINDEX PStringList::GetStringsIndex | ( | const PString & | str | ) | const

Get the index of the string with the specified value.

A linear search of list is performed to find the string value.

Parameters:

  str | String value to search for.

PINDEX PStringList::InsertString | ( | const PString & | before,
|  | const PString & | str |
| ) |  |  |

Insert a string into the list.

Parameters:

  before | String to insert before.
  str | String to insert.

PStringList PStringList::operator+ | ( | const PString & | str | ) |

PStringList PStringList::operator+ | ( | const PStringList & | array | ) |

Create a new PStringList, and add PString or PStringList to it a new PStringList.

Returns:
  A new PStringList with the additional elements(s)

PStringList& PStringList::operator+= | ( | const PString & | str | ) |

PStringList& PStringList::operator+= | ( | const PStringList & | list | ) |

Concatenate a PString or PStringArray to the list.

Returns:
  The PStringArray with the new items appended

virtual void PStringList::ReadFrom | ( | istream & | strm | ) | `[virtual]`

Input the contents of the object from the stream.

This is primarily used by the standard `operator>>` function.

The default behaviour reads '\n' separated strings until `!strm.good()`.

Reimplemented from PObject.

The documentation for this class was generated from the following file:

- pstring.h